import { computed as _, ref as f, watch as U, openBlock as $, createElementBlock as y, normalizeStyle as M, createElementVNode as C, createVNode as F, onMounted as J, nextTick as K, onBeforeUnmount as W, Fragment as E, normalizeClass as w, createCommentVNode as V, unref as Z, withModifiers as Q, renderList as ee } from "vue";
import { F as te, l as oe, X as ne } from "./index-C1GB0E49.js";
import S from "./BaseIcon-D9DRVW03.js";
import { _ as q } from "./_plugin-vue_export-helper-CHgC5LLL.js";
const ae = ["value"], le = { class: "icon" }, re = {
  __name: "ColorPicker",
  props: {
    value: {
      type: String,
      default: "#ffffff"
    },
    size: {
      type: String,
      default: "50px"
    }
  },
  emits: ["update:value"],
  setup(r, { emit: z }) {
    const i = r, d = _(() => ({
      backgroundColor: i.value,
      width: "100%",
      height: "100%",
      cursor: "pointer"
    })), v = f(null), X = () => {
      var p;
      (p = v.value) == null || p.click();
    }, b = (p) => {
      const m = p.target.value;
      z("update:value", m);
    }, x = _(() => te(i.value));
    return U(
      () => i.value,
      (p) => {
        v.value.value = p;
      }
    ), (p, m) => ($(), y("div", {
      style: M(d.value),
      class: "color-picker-wrapper",
      onClick: X
    }, [
      C("input", {
        ref_key: "colorInput",
        ref: v,
        type: "color",
        value: r.value,
        class: "hidden-input",
        onInput: b
      }, null, 40, ae),
      C("div", le, [
        F(S, {
          name: "palette",
          stroke: x.value,
          size: 22
        }, null, 8, ["stroke"])
      ])
    ], 4));
  }
}, se = /* @__PURE__ */ q(re, [["__scopeId", "data-v-d3f01240"]]), ue = {
  class: /* @__PURE__ */ w({
    "vue-ui-pen-and-paper-action": !0
  }),
  style: { padding: "0 !important" }
}, ce = ["disabled"], ie = ["xmlns", "viewBox", "onTouchstart", "onTouchmove"], de = ["d", "stroke"], pe = ["d", "stroke"], ve = {
  __name: "PenAndPaper",
  props: {
    parent: {
      type: HTMLElement
    },
    backgroundColor: {
      type: String,
      default: "#FFFFFF"
    },
    color: {
      type: String,
      default: "#2D353C"
    },
    active: {
      type: Boolean,
      default: !1
    }
  },
  emits: ["close"],
  setup(r, { emit: z }) {
    const i = r, d = f([]), v = f([]), X = f("0 0 0 0"), b = f(i.color), x = _(() => oe(i.color, 0.6));
    function p({ width: o, height: e }) {
      X.value = `0 0 ${o} ${e}`;
    }
    const m = f(null);
    J(() => {
      K(() => {
        if (i.parent) {
          m.value = new ResizeObserver((t) => {
            for (const s of t) {
              const { width: a, height: n } = s.contentRect;
              p({ width: a, height: n });
            }
          }), m.value.observe(i.parent);
          const { width: o, height: e } = i.parent.getBoundingClientRect();
          p({ width: o, height: e });
        }
      });
    }), W(() => {
      m.value && m.value.disconnect();
    }), U(
      () => i.parent,
      (o) => {
        if (!o) return;
        const { width: e, height: t } = i.parent.getBoundingClientRect();
        p({ width: e, height: t });
      },
      { immediate: !0 }
    );
    const P = f(!1), B = f(""), N = f(null);
    function D(o) {
      if (!N.value) return;
      P.value = !0;
      const { x: e, y: t } = Y(o);
      B.value = `M ${e} ${t}`;
    }
    function I(o) {
      if (!P.value || !N.value) return;
      const { x: e, y: t } = Y(o);
      B.value += ` ${e} ${t}`;
    }
    function A(o) {
      const e = o.trim().split(/\s+/);
      if (e.length < 4) return o;
      const t = [e[0], e[1], e[2]];
      for (let n = 3; n < e.length - 2; n += 2) {
        const l = parseFloat(e[n - 2]), k = parseFloat(e[n - 1]), h = parseFloat(e[n]), g = parseFloat(e[n + 1]);
        if (isNaN(l) || isNaN(k) || isNaN(h) || isNaN(g))
          continue;
        const u = (l + h) / 2, c = (k + g) / 2;
        t.push(`Q ${l} ${k} ${u} ${c}`);
      }
      const s = e[e.length - 2], a = e[e.length - 1];
      return t.push(`L ${s} ${a}`), t.join(" ");
    }
    function H(o) {
      const e = o.trim().split(/\s+/);
      let t = "", s = "", a = null, n = null;
      for (let l = 0; l < e.length; l += 1) {
        const k = e[l];
        if (isNaN(k)) {
          if (s = k, s === "M" || s === "L")
            a = parseFloat(e[++l]), n = parseFloat(e[++l]), t += `${s}${a} ${n}`;
          else if (s === "Q") {
            const h = parseFloat(e[++l]), g = parseFloat(e[++l]), u = parseFloat(e[++l]), c = parseFloat(e[++l]);
            h === a && g === n ? t += `t${u - a} ${c - n}` : t += `q${h - a} ${g - n} ${u - a} ${c - n}`, a = u, n = c;
          }
        } else {
          const h = parseFloat(k), g = parseFloat(e[++l]);
          if (s === "L") {
            const u = h - a, c = g - n;
            u === 0 ? t += `v${c}` : c === 0 ? t += `h${u}` : t += `l${u} ${c}`, a = h, n = g;
          } else if (s === "Q") {
            const u = h, c = g, T = parseFloat(e[++l]), R = parseFloat(e[++l]);
            u === a && c === n ? t += `t${T - a} ${R - n}` : t += `q${u - a} ${c - n} ${T - a} ${R - n}`, a = T, n = R;
          }
        }
      }
      return t;
    }
    function L() {
      P.value && (d.value.push(H(A(B.value))), v.value = [], B.value = ""), P.value = !1;
    }
    function Y(o) {
      if (!N.value) return { x: 0, y: 0 };
      const e = N.value.getBoundingClientRect();
      let t, s;
      return o.touches && o.touches.length ? (t = o.touches[0].clientX, s = o.touches[0].clientY) : (t = o.clientX, s = o.clientY), {
        x: t - e.left,
        y: s - e.top
      };
    }
    f(!1);
    function O() {
      if (d.value.length > 0) {
        const o = d.value.pop();
        v.value.push(o);
      }
    }
    function j() {
      if (v.value.length > 0) {
        const o = v.value.pop();
        d.value.push(o);
      }
    }
    function G() {
      d.value = [], v.value = [];
    }
    return (o, e) => ($(), y(E, null, [
      r.active ? ($(), y("div", {
        key: 0,
        "data-html2canvas-ignore": "",
        class: w({
          "vue-ui-pen-and-paper-actions": !0,
          visible: r.active
        })
      }, [
        C("button", {
          class: "vue-ui-pen-and-paper-action",
          style: M({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: e[0] || (e[0] = (t) => z("close"))
        }, [
          F(S, {
            name: "close",
            stroke: r.color
          }, null, 8, ["stroke"])
        ], 4),
        C("button", ue, [
          F(se, {
            value: b.value,
            "onUpdate:value": e[1] || (e[1] = (t) => b.value = t)
          }, null, 8, ["value"])
        ]),
        C("button", {
          class: w({
            "vue-ui-pen-and-paper-action": !0,
            "vue-ui-pen-and-paper-action-disabled": !d.value.length
          }),
          disabled: !d.value.length,
          style: M({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: O
        }, [
          F(S, {
            name: "restart",
            stroke: r.color
          }, null, 8, ["stroke"])
        ], 14, ce),
        C("button", {
          class: w({
            "vue-ui-pen-and-paper-action": !0,
            "vue-ui-pen-and-paper-action-disabled": !v.value.length
          }),
          style: M({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: j
        }, [
          F(S, {
            name: "restart",
            stroke: r.color,
            style: { transform: "scaleX(-1)" }
          }, null, 8, ["stroke"])
        ], 6),
        C("button", {
          class: w([{
            "vue-ui-pen-and-paper-action": !0,
            "vue-ui-pen-and-paper-action-disabled": !d.value.length
          }, "vue-ui-pen-and-paper-action"]),
          style: M({
            backgroundColor: r.backgroundColor,
            border: `1px solid ${x.value}`
          }),
          onClick: G
        }, [
          F(S, {
            name: "trash",
            stroke: r.color
          }, null, 8, ["stroke"])
        ], 6)
      ], 2)) : V("", !0),
      ($(), y("svg", {
        ref_key: "svgElement",
        ref: N,
        xmlns: Z(ne),
        viewBox: X.value,
        class: w({
          "vue-ui-pen-and-paper": !0,
          inactive: !r.active
        }),
        onMousedown: D,
        onMousemove: I,
        onMouseup: L,
        onMouseleave: L,
        onTouchstart: Q(D, ["prevent"]),
        onTouchmove: Q(I, ["prevent"]),
        onTouchend: L
      }, [
        ($(!0), y(E, null, ee(d.value, (t) => ($(), y("path", {
          class: "vue-ui-pen-and-paper-path",
          key: t,
          d: t,
          stroke: b.value,
          fill: "none"
        }, null, 8, de))), 128)),
        P.value ? ($(), y("path", {
          key: 0,
          class: "vue-ui-pen-and-paper-path vue-ui-pen-and-paper-path-drawing",
          d: B.value,
          stroke: b.value,
          fill: "none"
        }, null, 8, pe)) : V("", !0)
      ], 42, ie))
    ], 64));
  }
}, ke = /* @__PURE__ */ q(ve, [["__scopeId", "data-v-896ed082"]]);
export {
  ke as P
};
